/*******************************************************************************
 * Copyright (c) 2009 Patrik Jansson
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BSD license
 * which accompanies this distribution, see the COPYING file.
 *
 *******************************************************************************/
package org.owfs.jowfsclient;

import java.io.IOException;
import java.util.List;

import org.owfs.jowfsclient.Enums.OwAlias;
import org.owfs.jowfsclient.Enums.OwBusReturn;
import org.owfs.jowfsclient.Enums.OwDeviceDisplayFormat;
import org.owfs.jowfsclient.Enums.OwPersistence;
import org.owfs.jowfsclient.Enums.OwTemperatureScale;

public interface OwfsClient {

	void disconnect() throws IOException;

	void setTimeout(int timeout);

	void setDeviceDisplayFormat(OwDeviceDisplayFormat deviceDisplay);

	void setTemperatureScale(OwTemperatureScale tempScale);

	void setPersistence(OwPersistence persistence);

	void setAlias(OwAlias alias);

	void setBusReturn(OwBusReturn busReturn);

	String read(String path) throws IOException, OwfsException;

	void write(String path, String dataToWrite) throws IOException,
			OwfsException;

	Boolean exists(String path) throws IOException, OwfsException;

	List<String> listDirectoryAll(String path) throws OwfsException,
			IOException;

	List<String> listDirectory(String path) throws OwfsException, IOException;

}
